
-- SurgeonGeneral Listen Client by Brimmstone
-- Version 1.0

SGLC = LibStub("AceAddon-3.0"):NewAddon("SurgeonGeneral Listen Client", "AceConsole-3.0", "AceEvent-3.0", "AceComm-3.0", "AceSerializer-3.0")

local LTT=LibStub:GetLibrary("LibQTip-1.0");
local tooltip;

local options = {
	name = "SurgeonGeneral Listen Client",
	handler = SGLC,
    type = "group",
    args = {
		TooltipScale = {
			type = "range",
			name = "Tooltip Scale",
			desc = "Set scale of mouseover tooltip",
			min = 0.5,
			max = 1.5,
			step = 0.05,
			bigStep = 0.05,
			get = function() return SGLC.db.profile.TooltipScale end,
			set = function(_,value)
					SGLC.db.profile.TooltipScale = value
					tooltip:SetScale(SGLC.db.profile.TooltipScale)
				  end,
		},
	},
}

local defaults = {
	profile = {
		Verbose = false,
		Condense = true,
		TooltipScale = 1.0,
		SwapStyle = 1,
	},
}

function SGLC:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("SurgeonGeneralListenClientDB", defaults, "Default")
	LibStub("AceConfig-3.0"):RegisterOptionsTable("SurgeonGeneral Listen Client", options);
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("SurgeonGeneral Listen Client", "SurgeonGeneral Listen Client");
	tooltip = LTT:Acquire("SGLC_TT",3,"LEFT","CENTER","RIGHT");
	
	SGLC:RegisterComm("SGLC");
end

function SGLC:ForcePrint(msg,color)
	if color ~= nil then
		DEFAULT_CHAT_FRAME:AddMessage("|cff33ff99SGLC: |cff"..color..msg.."|r");
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cff33ff99SGLC: |cffffffff"..msg.."|r");
	end
end

function SGLC:OnLoad()
	
end

function SGLC:OnCommReceived(prefix, message, distro, sender)
	SGLC:ForcePrint("OnCommRx: "..prefix..", "..message..", "..distro..", "..sender);
end

function SGLC:CreateTooltip()
	-- Columns: [Icon],HealerName,Phase1_Assignment, [... Phase5_Assignment]
	local NumColumns = 7;
	local t = {};
	
	tooltip:Hide();
	tooltip:Clear();
	tooltip:SetScale(self.db.profile.TooltipScale);
	
	for x = 1,CalcPhases() do
		table.insert(t,"CENTER");
	end
	
	tooltip:SetColumnLayout(NumColumns,"LEFT","LEFT",unpack(t));
	tooltip:AddHeader("a");
	if (true) then
		tooltip:SetCell(1,1,"BossName","CENTER",NumColumns);
	else
		tooltip:SetCell(1,1,"SurgeonGeneral","CENTER",NumColumns);
	end
	
	tooltip:AddLine(" ");
	
	tooltip:AddLine("L");
	tooltip:SetCell(tooltip:GetLineCount(),1,"|cffff0000Left-Click|r to ....","LEFT",NumColumns)
	tooltip:AddLine("R");
	tooltip:SetCell(tooltip:GetLineCount(),1,"|cffff0000Right-Click|r to ....","LEFT",NumColumns)
	
end






local LDB = LibStub("LibDataBroker-1.1", true)
local L_SG_LEFT = "Left"
local L_SG_RIGHT = "Right"
	local launcher = LDB:NewDataObject("SGLC", {
	type = "data source",
	text = "SGLC",
	OnClick = function(_, msg)
		if msg == "LeftButton" then
			--
		elseif msg == "RightButton" then
			--
		end
	end,
	icon = "Interface\\Icons\\Spell_ChargePositive",
	OnEnter = function(self)
		SGLC:CreateTooltip();
		tooltip:SmartAnchorTo( self )
		tooltip:Show();
	end,
	OnLeave = function(self)
		tooltip:Hide();
	end,
})